' Ron Charlton explicitly places 'MakeEntropyTestData64.vb' in the public domain.
' It may be used for any purpose.
'
' $Id: MakeEntropyTestData64.vb 1.7 2014-06-18 13:09:18-04 Ron Exp $ $Name: release1dot7 $
'

Option Strict On
Option Explicit On

Module MakeEntropyTest_Data
	Sub MakeEntropyTestData64()
		' Write a file of random bytes.
		' Created by Ron Charlton, 2008-09-23, for Visual Basic .NET
		' Revised 2014-02-18 by Ron Charlton for 64 bits
		Dim i As Integer

		Const FileName As String = "MakeEntropyTestData64.out"

		' Rule of thumb: Need at least five samples in EVERY class (not just on average)
		Const count As Integer = CInt(256 * 1000)	' how many bytes to generate

		' VB 2005 creates arrays with size one greater than specified
		Dim bytes(count - 1) As Byte ' "count" bytes because it's the file size desired

		Dim r As New MTRandom64()

		Dim theFunction As String = "[ERROR]"

		' write random bytes into the array in sequence
		' (Don't fiddle with i; it's used as the array index.)
		For i = 0 To count - 1
			' Get a byte value between 0 inclusive and 255 inclusive.
			' (genrand64_int64() and genrand64_real2() are already tested by Main())
			' Comment out all but one of the following:
			'bytes(i) = CByte(Decimal.Floor((CDec(r.genrand64_int64()) / 18446744073709551616D) * 256D)) : theFunction = "genrand64_int64()"
			'bytes(i) = CByte(Int(r.genrand64_real2() * 256.0)) : theFunction = "genrand64_real2()"
			bytes(i) = CByte(r.genrand64_intMax(255)) : theFunction = "genrand64_intMax()"
			'bytes(i) = CByte(r.genrand64_intRange(0, 255)) : theFunction = "genrand64_intRange()"
		Next

		' Write the entire bytes() array to a file.  False == don't append.
		My.Computer.FileSystem.WriteAllBytes(FileName, bytes, False)

		' Tell the user it was done
		Console.WriteLine(ControlChars.NewLine & "{0} random bytes generated by {1} were written to", _
		 count.ToString(), theFunction)
		Console.WriteLine("file '{0}'." & ControlChars.NewLine, FileName)

		Console.WriteLine("Press the <Enter> key to continue.")
		Console.ReadLine()

	End Sub		'MakeEntropyTestData64
End Module
