﻿Option Strict On
Option Explicit On

Module Test_init_by_crypto64_Module
	' $Id: Test_init_by_crypto64.vb 1.7 2014-06-18 13:09:18-04 Ron Exp $ $Name: release1dot7 $

	' Create a file of crypto-pseudorandom bytes from MTRandom64.init_by_crypto64() initializers
	Public Sub Test_init_by_crypto64(byteCount As Integer)
		If byteCount <= 0 Then Return

		' name of output file
		Const filename As String = "Test_init_by_crypto64.out"
		Dim ul As ULong, i As Integer = 0, byteIdx As Integer
		Dim data(byteCount - 1) As Byte	  ' Byte is unsigned
		Dim crypto As New MTRandom64(0.0)

		Console.Write("Writing {0} CryptoRNGServiceProvider bytes to {1} ...", byteCount, filename)

		Dim last As Integer = crypto.state64.mt.GetUpperBound(0)
		For byteIdx = 0 To byteCount - 1
			' If (byteIdx Mod 8) = 0 Then get a crypto-pseudorandom number
			If (byteIdx And 7) = 0 Then
				ul = crypto.state64.mt(i)
				i += 1
				If i > last Then
					crypto.init_by_crypto64(0.0)	' get more crypto data
					i = 0
				End If
			End If

			' x86/x64 (little-endian) byte order
			data(byteIdx) = CByte(ul And &HFFUL)
			ul >>= 8
		Next byteIdx

		' False means overwrite the file
		My.Computer.FileSystem.WriteAllBytes(filename, data, False)

		Console.WriteLine(" Done.")
		Console.WriteLine("Press the <Enter> key to continue.")
		Console.ReadLine()
	End Sub
End Module
